import {login, logout, getInfo, submitCode} from '@/api/login'
import { getToken, setToken, removeToken } from '@/utils/auth'
import defAva from '@/assets/images/profile.jpg'

const useUserStore = defineStore(
  'user',
  {
    state: () => ({
      token: getToken(),
      id: '',
      name: '',
      avatar: '',
      roles: [],
      permissions: []
    }),
    actions: {
      // 登录
      login(userInfo) {
        const mobile = userInfo.mobile.trim()
        const password = userInfo.password
        const code = userInfo.code

        return new Promise((resolve, reject) => {
          login(mobile, password, code).then(res => {
            setToken(res.data.accessToken)
            this.token = res.data.accessToken
            resolve()
          }).catch(error => {
            reject(error)
          })
        })
      },
      cellPhoneLogin(userInfo) {
        const mobile = userInfo.mobile.trim()
        const code = userInfo.code
        return new Promise((resolve, reject) => {
          submitCode({mobile:mobile, code:code}).then(res => {
            setToken(res.data.accessToken)
            this.token = res.data.accessToken
            resolve()
          }).catch(error => {
            reject(error)
          })
        })
      },
      // 获取用户信息
      getInfo() {
        return new Promise((resolve, reject) => {
          getInfo().then(res => {
            const user = res.data
            const avatar = (user.avatar == "" || user.avatar == null) ? defAva : user.avatar;

            /*if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
              this.roles = res.roles
              this.permissions = res.permissions
            } else {
              this.roles = ['ROLE_DEFAULT']
            }*/
            this.id = user.id
            this.name = user.mobile
            this.avatar = avatar
            resolve(res)
          }).catch(error => {
            reject(error)
          })
        })
      },
      // 退出系统
      logOut() {
        return new Promise((resolve, reject) => {
          logout(this.token).then(() => {
            this.token = ''
            this.roles = []
            this.permissions = []
            removeToken()
            resolve()
          }).catch(error => {
            reject(error)
          })
        })
      }
    }
  })

export default useUserStore
